Subject: bug#49139: Cannot delete *help* buffer

From: [email-masked]
Date: Mon, 21 Jun 2021 02:15:31 +0200 (CEST)

From: Stephen Berman <[email-masked]>
To: [email-masked]
Subject: Re: bug#49139: Cannot delete *help* buffer
Date: 20/06/2021 23:55:13 Europe/Paris
Cc: [email-masked]

On Sun, 20 Jun 2021 17:49:57 +0200 (CEST) [email-masked] wrote:

> When I use "C-h f myfunc" I get the docstring in the *help* buffer. I
> can close the window with "C-x 1".
>
> But tring to close the *help* buffer does not work. I press on the
> "Red Cross" and the *help* buffer remains present in the Buffers Menu
> Bar.
>
> If I press the "Red Cross" on the *scratch* and *messages* buffers,
> the two buffers get removed from the Buffers Menu Bar.

This is a change in behavior from Emacs 27 due to this change:

commit c85c8e7d42ae2a5fc95fa7b14257389d8383b34d
Author: Stefan Kangas <[email-masked]>
Commit: Stefan Kangas <[email-masked]>
CommitDate: Sat Feb 20 06:43:03 2021 +0100

Add toolbar for help-mode

Prior to this change, clicking the X icon in the tool bar when *Help* is
the current buffer does kill the buffer, but since the change it just
buries the buffer. This change should be called out in NEWS.

Emacs does give indirect notification of this difference between
clicking the X icon when *Help* is the current buffer and when a buffer
such as *scratch* is current: if you hover the mouse pointer over the
icon when *scratch* is current, you get a tooltip saying "Discard (kill)

current buffer", 

* Correct, I get  "Discard (kill) current buffer"

while with *Help* current the tooltip says "Quit help (q)". 

* Also correct, I get "Quit help(q) "

And if you type `C-h k' with *Help* current and then click the X

icon, the *Help* buffer now says 

"<tool-bar> <quit> runs the command quit-window [...]" 

* yes, it does say tho above

and further down explains how it is in fact possible
to kill the *Help* buffer from the tool bar: type a prefix argument
(C-u) and then click the icon.

* It gets very cryptic now because it says

* "With prefix argument KILL non-nil, kill the buffer instead of
* burying it."

* After trying it, type a prefix argument (C-u) and then click the icon,

* one is indeed able to kill the buffer.

I use the help buffer to read documentation or to write some information 

temporarily.  Do we really need such complication (C-u) to kill the buffer

when just clicking the icon is a standard way to kill it ?.

Steve Berman